///////////////////////////////////////////////////////////////////////////
//
//	SDBTree
//		kaj: Jun 4 1997
//		Purpose: cover for IXBTreeCursor methods
//
///////////////////////////////////////////////////////////////////////////

@class SDBTreeCursor, NSStore;

extern NSString *SDBTreeIndexDidBecomeInvalid;


@interface SDBTree:NSObject

{
    NSString *name;
    NSMutableDictionary *contentDictionary;
    NSMutableArray *orderedKeys;
    int (*comparator)(id,id,void *);
    void *comparatorContext;
//    NSMutableArray *cursorList;
    unsigned int blockNumber;
    SDStore *storeFile;
    BOOL dirty;
}

+ (int (*) (id,id,void *)) defaultComparator;
+ (void) freeFromBlock:(unsigned int) aBlockNumber inStore:(SDStore *)aStoreFile;
- (id) initInStore:(SDStore *)aStoreFile;
- (id) initFromBlock:(unsigned int) blockNo inStore:(SDStore *)aStoreFile;
- (void) setComparator: (SDComparator *)aComparator andContext:(void *)aContext ;
- (void) getComparator: (SDComparator **)aComparator andContext:(void **)aContext;
- (unsigned int) indexForKey:(NSData *)aKey exactMatch: (BOOL *)exactMatch;
- (BOOL) insertValue:(NSData *)aValue andKey:(NSData *)aKey atIndex:(unsigned int)index ;
- (void) removeValueAtIndex:(unsigned int)index withKey:(NSData *)key;
- (NSData *) valueAtIndex:(unsigned int)index;
- (NSData *) keyAtIndex:(unsigned int) index;
- (BOOL) indexBeyondLastKey:(unsigned int) index;
- (int)lastIndex;
- (BOOL) isEmpty;
- (void) setDirty:(BOOL) flag;
- (BOOL) isDirty;
- (int) blockNumber;
- (void) getBlock:(unsigned int *)aBlock andStore:(SDStore **)aStore;
- (void) commitTransaction;
- (unsigned) keyLimit;
- (void) empty;
- (unsigned) count;
- (void) freeFromStore;
- (void) setStore: (SDStore *)aStore;


@end
