///////////////////////////////////////////////////////////////////////////
//
//	SDBTreeCursor
//		kaj: Jun 4 1997
//		Purpose: cover for IXBTreeCursor methods
//
///////////////////////////////////////////////////////////////////////////


@interface SDBTreeCursor:NSObject
{
    SDBTree *btree;		//implemented as an NSDictionary and NSArray
    unsigned int index;		//current position in array
    NSData *currentKey;
    BOOL currentKeyFoundInBTree;
    BOOL validIndex;
    BOOL isRegistered;
}

- (id)initWithBTree: (SDBTree *)aBTree ;
- (void) setKeyForIndex:(unsigned int) newIndex;
- (BOOL) writeValue: (void *)aValue andLength: (unsigned int)length;
- (void) writeData:(NSData *)data;
- (void) writeRange:(const void *)aRange ofLength:(unsigned int)aLength atOffset:(unsigned int)anOffset;
- (void) removeValue;
- (NSData *)readData;
- (unsigned int) readValue: (void **)buffer;
- (BOOL) setLast;
- (BOOL) setFirst;
- (BOOL) setNext;
- (BOOL) setPrevious;
- (BOOL) setKey: (NSData *)aKey;
- (void) resetKey;
- (BOOL) setKey:(const void *)aKey andLength:(unsigned int) length;
- (BOOL)setKey:(const void *)aKey andLength:(unsigned int)aLength withHint:(unsigned int)aHint;
- (BOOL) setKey:(NSData *)newKey withHint:(HINT_TYPE)aHint;
- (NSData *) getKey;
- (BOOL) getKeyData:(NSData **)aKey withHint:(HINT_TYPE *)aHint;
- (BOOL) getKey:(const void **)aKey andLength:(unsigned int *) length;
- (BOOL)getKey:(const void **)aKey andLength:(unsigned int *)aLength withHint:(HINT_TYPE *)aHint;
- (BOOL) isMatch;
- (unsigned long) currentPosition;

- (void)invalidateIndex:(NSNotification *)aNotification;
- (SDBTree *)btree;

@end
