///////////////////////////////////////////////////////////////////////////
//
//	SDStore
//		kaj: Jun 4 1997
//		Purpose: cover for IXStore methods
//
///////////////////////////////////////////////////////////////////////////

@class SDStoreDirectory;

@interface SDStore:NSObject
{
    unsigned int lastBlock;
    NSMutableDictionary *rootDictionary;
    NSMutableDictionary *privateInfo;
    NSMutableArray *clientList;
    unsigned int transactionLevel;
}

// IXCover methods
- (void) createBlock:(int *)blockNumber withSize:(unsigned int)aSize;
- (unsigned int) startTransaction;
- (void) commitTransaction;
- (unsigned int) nestingLevel;
- (void) freeBlock:(int) aBlockNumber;

// other methods
- (id)readBlock:(int)blockNumber;
- (void) writeData:(NSData *)blockData toBlock:(int)blockNumber;
- (void) recordLastBlockNumber;
- (int) readLastBlockNumber;
- (void) registerClient:(id)aClient;
- (void) unregisterClient:(id)aClient;

extern NSString *SDStoreTransactionWasCommitted;

@end
